package com.ruoyi.system.domain.form;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class MdFormRecordExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public MdFormRecordExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andFormIdIsNull() {
            addCriterion("form_id is null");
            return (Criteria) this;
        }

        public Criteria andFormIdIsNotNull() {
            addCriterion("form_id is not null");
            return (Criteria) this;
        }

        public Criteria andFormIdEqualTo(String value) {
            addCriterion("form_id =", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdNotEqualTo(String value) {
            addCriterion("form_id <>", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdGreaterThan(String value) {
            addCriterion("form_id >", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdGreaterThanOrEqualTo(String value) {
            addCriterion("form_id >=", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdLessThan(String value) {
            addCriterion("form_id <", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdLessThanOrEqualTo(String value) {
            addCriterion("form_id <=", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdLike(String value) {
            addCriterion("form_id like", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdNotLike(String value) {
            addCriterion("form_id not like", value, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdIn(List<String> values) {
            addCriterion("form_id in", values, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdNotIn(List<String> values) {
            addCriterion("form_id not in", values, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdBetween(String value1, String value2) {
            addCriterion("form_id between", value1, value2, "formId");
            return (Criteria) this;
        }

        public Criteria andFormIdNotBetween(String value1, String value2) {
            addCriterion("form_id not between", value1, value2, "formId");
            return (Criteria) this;
        }

        public Criteria andStatusIsNull() {
            addCriterion("status is null");
            return (Criteria) this;
        }

        public Criteria andStatusIsNotNull() {
            addCriterion("status is not null");
            return (Criteria) this;
        }

        public Criteria andStatusEqualTo(Integer value) {
            addCriterion("status =", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotEqualTo(Integer value) {
            addCriterion("status <>", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThan(Integer value) {
            addCriterion("status >", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("status >=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThan(Integer value) {
            addCriterion("status <", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusLessThanOrEqualTo(Integer value) {
            addCriterion("status <=", value, "status");
            return (Criteria) this;
        }

        public Criteria andStatusIn(List<Integer> values) {
            addCriterion("status in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotIn(List<Integer> values) {
            addCriterion("status not in", values, "status");
            return (Criteria) this;
        }

        public Criteria andStatusBetween(Integer value1, Integer value2) {
            addCriterion("status between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("status not between", value1, value2, "status");
            return (Criteria) this;
        }

        public Criteria andCommitStatusIsNull() {
            addCriterion("commit_status is null");
            return (Criteria) this;
        }

        public Criteria andCommitStatusIsNotNull() {
            addCriterion("commit_status is not null");
            return (Criteria) this;
        }

        public Criteria andCommitStatusEqualTo(Integer value) {
            addCriterion("commit_status =", value, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusNotEqualTo(Integer value) {
            addCriterion("commit_status <>", value, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusGreaterThan(Integer value) {
            addCriterion("commit_status >", value, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("commit_status >=", value, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusLessThan(Integer value) {
            addCriterion("commit_status <", value, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusLessThanOrEqualTo(Integer value) {
            addCriterion("commit_status <=", value, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusIn(List<Integer> values) {
            addCriterion("commit_status in", values, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusNotIn(List<Integer> values) {
            addCriterion("commit_status not in", values, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusBetween(Integer value1, Integer value2) {
            addCriterion("commit_status between", value1, value2, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("commit_status not between", value1, value2, "commitStatus");
            return (Criteria) this;
        }

        public Criteria andCommitCycleIsNull() {
            addCriterion("commit_cycle is null");
            return (Criteria) this;
        }

        public Criteria andCommitCycleIsNotNull() {
            addCriterion("commit_cycle is not null");
            return (Criteria) this;
        }

        public Criteria andCommitCycleEqualTo(String value) {
            addCriterion("commit_cycle =", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleNotEqualTo(String value) {
            addCriterion("commit_cycle <>", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleGreaterThan(String value) {
            addCriterion("commit_cycle >", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleGreaterThanOrEqualTo(String value) {
            addCriterion("commit_cycle >=", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleLessThan(String value) {
            addCriterion("commit_cycle <", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleLessThanOrEqualTo(String value) {
            addCriterion("commit_cycle <=", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleLike(String value) {
            addCriterion("commit_cycle like", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleNotLike(String value) {
            addCriterion("commit_cycle not like", value, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleIn(List<String> values) {
            addCriterion("commit_cycle in", values, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleNotIn(List<String> values) {
            addCriterion("commit_cycle not in", values, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleBetween(String value1, String value2) {
            addCriterion("commit_cycle between", value1, value2, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCommitCycleNotBetween(String value1, String value2) {
            addCriterion("commit_cycle not between", value1, value2, "commitCycle");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Long value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Long value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Long value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Long value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Long value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Long value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Long> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Long> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Long value1, Long value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Long value1, Long value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andOwnUserIsNull() {
            addCriterion("own_user is null");
            return (Criteria) this;
        }

        public Criteria andOwnUserIsNotNull() {
            addCriterion("own_user is not null");
            return (Criteria) this;
        }

        public Criteria andOwnUserEqualTo(String value) {
            addCriterion("own_user =", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotEqualTo(String value) {
            addCriterion("own_user <>", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserGreaterThan(String value) {
            addCriterion("own_user >", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserGreaterThanOrEqualTo(String value) {
            addCriterion("own_user >=", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserLessThan(String value) {
            addCriterion("own_user <", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserLessThanOrEqualTo(String value) {
            addCriterion("own_user <=", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserLike(String value) {
            addCriterion("own_user like", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotLike(String value) {
            addCriterion("own_user not like", value, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserIn(List<String> values) {
            addCriterion("own_user in", values, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotIn(List<String> values) {
            addCriterion("own_user not in", values, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserBetween(String value1, String value2) {
            addCriterion("own_user between", value1, value2, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnUserNotBetween(String value1, String value2) {
            addCriterion("own_user not between", value1, value2, "ownUser");
            return (Criteria) this;
        }

        public Criteria andOwnDeptIsNull() {
            addCriterion("own_dept is null");
            return (Criteria) this;
        }

        public Criteria andOwnDeptIsNotNull() {
            addCriterion("own_dept is not null");
            return (Criteria) this;
        }

        public Criteria andOwnDeptEqualTo(String value) {
            addCriterion("own_dept =", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotEqualTo(String value) {
            addCriterion("own_dept <>", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptGreaterThan(String value) {
            addCriterion("own_dept >", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptGreaterThanOrEqualTo(String value) {
            addCriterion("own_dept >=", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptLessThan(String value) {
            addCriterion("own_dept <", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptLessThanOrEqualTo(String value) {
            addCriterion("own_dept <=", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptLike(String value) {
            addCriterion("own_dept like", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotLike(String value) {
            addCriterion("own_dept not like", value, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptIn(List<String> values) {
            addCriterion("own_dept in", values, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotIn(List<String> values) {
            addCriterion("own_dept not in", values, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptBetween(String value1, String value2) {
            addCriterion("own_dept between", value1, value2, "ownDept");
            return (Criteria) this;
        }

        public Criteria andOwnDeptNotBetween(String value1, String value2) {
            addCriterion("own_dept not between", value1, value2, "ownDept");
            return (Criteria) this;
        }


        public Criteria andSourceIsNull() {
            addCriterion("source is null");
            return (Criteria) this;
        }

        public Criteria andSourceIsNotNull() {
            addCriterion("source is not null");
            return (Criteria) this;
        }

        public Criteria andSourceEqualTo(String value) {
            addCriterion("source =", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceNotEqualTo(String value) {
            addCriterion("source <>", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceGreaterThan(String value) {
            addCriterion("source >", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceGreaterThanOrEqualTo(String value) {
            addCriterion("source >=", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceLessThan(String value) {
            addCriterion("source <", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceLessThanOrEqualTo(String value) {
            addCriterion("source <=", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceLike(String value) {
            addCriterion("source like", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceNotLike(String value) {
            addCriterion("source not like", value, "source");
            return (Criteria) this;
        }

        public Criteria andSourceIn(List<String> values) {
            addCriterion("source in", values, "source");
            return (Criteria) this;
        }

        public Criteria andSourceNotIn(List<String> values) {
            addCriterion("source not in", values, "source");
            return (Criteria) this;
        }

        public Criteria andSourceBetween(String value1, String value2) {
            addCriterion("source between", value1, value2, "source");
            return (Criteria) this;
        }

        public Criteria andSourceNotBetween(String value1, String value2) {
            addCriterion("source not between", value1, value2, "source");
            return (Criteria) this;
        }

        public Criteria andCommitNameIsNull() {
            addCriterion("commit_name is null");
            return (Criteria) this;
        }

        public Criteria andCommitNameIsNotNull() {
            addCriterion("commit_name is not null");
            return (Criteria) this;
        }

        public Criteria andCommitNameEqualTo(String value) {
            addCriterion("commit_name =", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameNotEqualTo(String value) {
            addCriterion("commit_name <>", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameGreaterThan(String value) {
            addCriterion("commit_name >", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameGreaterThanOrEqualTo(String value) {
            addCriterion("commit_name >=", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameLessThan(String value) {
            addCriterion("commit_name <", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameLessThanOrEqualTo(String value) {
            addCriterion("commit_name <=", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameLike(String value) {
            addCriterion("commit_name like", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameNotLike(String value) {
            addCriterion("commit_name not like", value, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameIn(List<String> values) {
            addCriterion("commit_name in", values, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameNotIn(List<String> values) {
            addCriterion("commit_name not in", values, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameBetween(String value1, String value2) {
            addCriterion("commit_name between", value1, value2, "commitName");
            return (Criteria) this;
        }

        public Criteria andCommitNameNotBetween(String value1, String value2) {
            addCriterion("commit_name not between", value1, value2, "commitName");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}